<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<link rel="alternate"
      type="application/rss+xml"
      href="https://blog.winny.tech/rss.xml"
      title="RSS feed for https://blog.winny.tech/"/>
<title>blog.winny.tech</title>

<link href="static/style.css?v=1.13" rel="stylesheet" type="text/css" />
<meta name="viewport" content="width=device-width, initial-scale=1">
</head>
<body>
<div id="preamble" class="status">
<nav>
<div class="flexcontainer">
<div class="smallitem">
<ul class="inline-list">
<li><a href=".">blog.winny.tech</a></li>
<li><a href="https://winny.tech/">About</a></li>
</ul>
</div>
<div class="bigitem">
<ul class="inline-list">
<li><a href="archive.html">Archive</a></li>
<li><a href="tags.html">Tags</a></li>
<li><a href="rss.xml">RSS Feed</a></li>
</ul>
</div>
</div>
</nav>
<hr/>
</div>
<div id="content">
<h1 class="title">Posts tagged "devops":</h1>
<div class="post-date">31 Aug 2020</div><h1 class="post-title"><a href="2020-08-12-when-nat-bites-—-use-a-reverse-vpn.html">When NAT Bites — Use a Reverse VPN</a></h1>
<nav id="table-of-contents">
<h2>Table of Contents</h2>
<div id="text-table-of-contents">
<ul>
<li><a href="#org10cdd91">How to ssh into a home server box &#x2014; the standard way</a>
<ul>
<li><a href="#orgae3d30c">Allowing ssh logins oven IPv6</a></li>
<li><a href="#org356e451">Allowing ssh logins over IPv4</a></li>
</ul>
</li>
<li><a href="#org1362730">What can go wrong?</a></li>
<li><a href="#org69f0fbd">A few options</a>
<ul>
<li><a href="#org91d635e">Punt the socket using socat</a></li>
<li><a href="#org1158eb6">Better: Using OpenSSH</a></li>
<li><a href="#org47c2aa6">My Solution: Use OpenVPN</a></li>
</ul>
</li>
<li><a href="#orgf61e06b">Steps to set up (based off my playbooks)</a>
<ul>
<li><a href="#orgabc7cda">Set up the certificate authority &amp; certificates</a></li>
<li><a href="#org2b654f1">Set up the OpenVPN Server (Internet-side)</a></li>
<li><a href="#org72b01c1">Set up the OpenVPN Client (Your Firewalled Host)</a></li>
<li><a href="#org6358f82">Set up another OpenVPN client on your PC</a></li>
</ul>
</li>
<li><a href="#orgb426dff">Wishlist</a>
<ul>
<li><a href="#orgb3b4552">VPN Host Discovery</a></li>
<li><a href="#org63d31e1">Domain Names for VPN Hosts</a></li>
<li><a href="#org5f7d008">Configure the VPN Clients' LAN segments be routable from other Clients</a></li>
</ul>
</li>
</ul>
</div>
</nav>
<p>
Sometimes I find myself setting up servers on networks with less than ideal
network configuration.  Most home internets use dynamic IP addresses, which
requires extra work to ensure I know the IP address to use when logging into
the network from the internet.  Another concern is how unreliable home
networking gear can be, especially with users tweaking settings without fully
appreciating what they're doing.  As a result, I've devised an alternate
solution to ensure I can always log into boxes hosted on home internet
connections.
</p>

<div id="outline-container-org10cdd91" class="outline-2">
<h2 id="org10cdd91">How to ssh into a home server box &#x2014; the standard way</h2>
<div class="outline-text-2" id="text-org10cdd91">
<p>
Let's say I am to set up a box on a home network.  I want to ensure I can log
in via SSH from the outside world &#x2014; that is anywhere online.  In IPv6 and
IPv4 land it is equally painful and possibly unreliable.
</p>
</div>

<div id="outline-container-orgae3d30c" class="outline-3">
<h3 id="orgae3d30c">Allowing ssh logins oven IPv6</h3>
<div class="outline-text-3" id="text-orgae3d30c">
<p>
After setting up the box on the network, I will need to configure the router's
<b>firewall</b> to allow SSH traffic on through.  In the case of IPv6 this is as
simple as telling the router to allow traffic inbound on port 22 to my box's
IPv6 address, which is globally routable and unique to my box.  One more thing:
the ISP gives each IPv6-enabled subscriber a IPv6 prefix, which is a bunch of
IPv6 addresses that the customer's equipment utilize via SLAAC.  Let's work
through an example:
</p>

<ol class="org-ol">
<li>The ISP gives your router IPv6 prefix <code>2001:db8:a:b::/64</code><sup><a id="fnr.1" class="footref" href="#fn.1">1</a></sup> via DHCPv6</li>
<li>Every device on the network assigns itself an IPv6 address via SLAAC</li>
<li>Each device on the network is globally routed via a unique IPv6 address.
For example the server box is <code>2001:db8:a:b::1</code>, the router is
<code>2001:db8:a:b::5:1</code>, and my phone is <code>2001:db8:a:b::c:d</code>.</li>
<li>I want to log into the server box.  I ssh in to the server box's address
directly.</li>
<li>The router permits SSH traffic to my server box through its firewall</li>
<li>Success!  I am logged in.</li>
</ol>

<p>
It seems pretty straight forward, But there is a catch: when your DHCPv6 lease
expires (e.g. 1 week), there is a possibility your network is assigned a new
IPv6 prefix.  Hence the IPv6 address can be thought as dynamic.
</p>

<p>
In order to get around this limitation, one can use Dynamic DNS and update a
AAAA DNS record for every host on the LAN that needs to be accessed via the
internet.  This means you'll either have to run a Dynamic DNS client on each
host, or use some sort of host discovery to set Dynamic DNS AAAA records on
another host's behalf.  Seems a bit confusing; in short when using IPv6 on a
home network, special care is needed to ensure SSH is accessible.
</p>
</div>
</div>

<div id="outline-container-org356e451" class="outline-3">
<h3 id="org356e451">Allowing ssh logins over IPv4</h3>
<div class="outline-text-3" id="text-org356e451">
<p>
Looking at IPv4, some things differ.  As in IPv6's case, one needs to allow SSH
traffic to the target box on the home network.  What differs is one does not
directly address the internal host; instead one has to address the router
(which is usually plugged directly into the modem/internet).  The router then
passes this SSH traffic to the box on the home network.  In effect the router
is <b>translating</b> between different network segments.  The feature of your
router passing traffic on a port to another host on the home network is known
as <b>port forwarding</b>.
</p>

<p>
Now that we understand the main difference, we should also discuss how IPv4
addresses are given to home ISP users.  Typically the mechanism of how your
home router gets an IPv4 address is the same as how your personal devices get
addresses from the router.  In both cases the device requesting an address uses
DHCP to solicit a IPv4 address and related configuration (such as DNS servers
and default gateway).  Again the same process is applied to each device on the
home network.  They simply get IPv4 addresses from the router, but in this
case, the router does not give out globally routable addresses, but instead
gives out private IPv4 addresses.  These private IPv4 addresses are not
globally routable, and instead depend on the router to figure out where to send
internet stuff.  Also, as with DHCPv6, there is a finite lifespan for DHCP
leases.  As such after awhile, your router's IPv4 address may change.
</p>

<p>
Let's work through a IPv4 example:
</p>

<ol class="org-ol">
<li>Your router solicits a IPv4 address from the ISP, such as <code>203.0.113.1</code>.<sup><a id="fnr.2" class="footref" href="#fn.2">2</a></sup>
This is the only internet-routable address used in the setup.</li>
<li>Each device on the network solicits an IPv4 address from the router.<sup><a id="fnr.3" class="footref" href="#fn.3">3</a></sup>
Each device has its own private IPv4 address.<sup><a id="fnr.4" class="footref" href="#fn.4">4</a></sup>  In this example the server
box has <code>192.168.1.20</code>, the router has <code>192.168.1.1</code>, my phone has
<code>192.168.1.101</code>.</li>
<li>Internet traffic is directed towards the router (acting as the <b>default
gateway</b>), which in turn translates the network traffic.  This is done by
replacing the <b>private IPv4 address</b> and <b>source port</b> with the <b>public IPv4
address</b> and a <b>"session port"</b>, which is used to uniquely map between
traffic belonging on the internet side to traffic belonging on the home
network side.  This is <b>network address translation</b>.</li>
<li>When I want to log into the server box, I ssh into the router's public IPv4
address.</li>
<li>The router translates the ssh traffic to a the private IPv4 address space
and sends it off to the server box.  The server box then handles the ssh
session sent from the router, which then the router relays back and forth
between the server box on the private LAN with my internet computer.</li>
</ol>

<p>
Seems a bit convoluted too.  But it does work.  When combined with Dynamic DNS
to update an A DNS record for the router's public IPv4 address, it can work
pretty flawlessly.
</p>
</div>
</div>
</div>

<div id="outline-container-org1362730" class="outline-2">
<h2 id="org1362730">What can go wrong?</h2>
<div class="outline-text-2" id="text-org1362730">
<p>
When using any of the above approaches to set up SSH login, a few things can go
wrong.
</p>

<ol class="org-ol">
<li>In both IPv4 and IPv6, the router depends on the ISP to assign internet
addresses.  As such in both cases, Dynamic DNS or a similar mechanism is
needed to ensure I can log in via a DNS record, or at least know what
address works when using SSH.  If I don't know the latest internet address,
I cannot log in.</li>

<li>The router has to be specially configured to allow traffic in both IPv4 and
IPv6 situations.  Using IPv6, the router must permit traffic to the server box.
Using IPv4, the router has modify network traffic it receives on the SSH
port and pass it on to the server box.  And then it does the same to send
traffic back to my internet device.  If the router configuration breaks for
whatever reason, I cannot log in.</li>

<li>Some internet connections cannot receive SSH traffic.  Most mobile internet
service providers (such as ATE) use <b>Carrier Grade NAT</b> to allow multiple
internet subscribers to connect to the internet using the same public IPv4
address.  Port forwarding won't work with Carrier Grade NAT.  Additionally
some ISPs do nefarious things like blocking ports for you.  After all it's
pretty normal for ISPs to block SMTP (even if I think it's bonkers).</li>
</ol>

<p>
In short the network operator must cooperate with you to make this happen.  In
some cases the hardware isn't capable either.
</p>
</div>
</div>

<div id="outline-container-org69f0fbd" class="outline-2">
<h2 id="org69f0fbd">A few options</h2>
<div class="outline-text-2" id="text-org69f0fbd">
<p>
Before continuing I'd like to point out—like most technology—the exact same
tools every single user uses daily (in one form or fashion) can be used to
attack the same systems.  As such the next example is for demonstration
purposes.  Data is sent plain text and no authentication/verification of host
or user is performed.  Computers networks are only as secure as their users ;).
</p>
</div>

<div id="outline-container-org91d635e" class="outline-3">
<h3 id="org91d635e">Punt the socket using socat</h3>
<div class="outline-text-3" id="text-org91d635e">
<p>
One can use socat to (1) run a socat client that connects to a internet server,
which sends all data to the home server box's SSH port and (2) run a socat
server on the internet host which sends traffic it receives to the socat client
connected on another port on the internet server.
</p>

<p>
Let's try this out: given host <code>public.example.com</code> and your LAN host
<code>not-reachable.lan</code>, run <code>socat TCP-LISTEN:9991,fork,forever TCP-LISTEN:9992</code>
on <code>public.example.com</code>, then run <code>socat
TCP-CONNECT:public.example.com:9991,fork,forever TCP-CONNECT:localhost:22</code> on
<code>not-reachable.lan</code>.  Now run <code>ssh -p 9992 public.example.com</code>.  You should see
the familiar messages of OpenSSH.
</p>

<p>
Sounds a bit confusing, because it is.  Additionally there is not an easy
mechanism to ensure multiple ssh sessions can be used simultaneously, and to
ensure the authenticity of the socat client that connects to the internet
server.  So I wouldn't use this in production ;).  Note: socat can use OpenSSL,
which can address the authenticity problem, but I still don't think this is a
very intuitive way to solve the problem.
</p>


<figure>
<img src="../static/image/20200901_socat_diagram.png" alt="20200901_socat_diagram.png">

<figcaption><span class="figure-number">Figure 1: </span>socat topology.  Arrows point away from the connecting socket to the destination process.</figcaption>
</figure>
</div>
</div>

<div id="outline-container-org1158eb6" class="outline-3">
<h3 id="org1158eb6">Better: Using OpenSSH</h3>
<div class="outline-text-3" id="text-org1158eb6">
<p>
During a recent episode of <a href="https://linuxunplugged.com/">Linux Unplugged</a>, there was discussion of using
OpenSSH to dial in to a internet-reachable host.  The secret sauce is to use
the <code>RemoteForward</code> option (<code>ssh -R</code>).  This can be achieved like <code>ssh -R
2222:localhost:22 my-server.example</code>.  Then from the server, one can run <code>ssh
-p 2222 localhost</code> to log into the firewalled host's SSH server.  Alternately,
OpenSSH also supports forwarding a SOCKS5 proxy, which can be used in
conjunction with a web browser to browse web configuration UIs with little
effort, or with use other applications via the tool proxychains.
</p>


<figure>
<img src="../static/image/20200901_ssh_diagram.png" alt="20200901_ssh_diagram.png">

<figcaption><span class="figure-number">Figure 2: </span>ssh reverse port forwarding topology.</figcaption>
</figure>
</div>
</div>


<div id="outline-container-org47c2aa6" class="outline-3">
<h3 id="org47c2aa6">My Solution: Use OpenVPN</h3>
<div class="outline-text-3" id="text-org47c2aa6">
<p>
I wanted to allow for the firewalled host be accessible as an unique network
address, without need for SOCKS5 or other steps.  The solution I came up with
is to stand up a OpenVPN server process on the internet host, then run OpenVPN
client on the remote host.  The configuration is deceptively simple, despite
OpenVPN's featureful footprint.
</p>

<p>
Some OpenVPN operators allow users to log in via username or password
associated with their account, but this appears a bit complicated to set up.
Instead, the OpenVPN folks recommend setting up a Self-signed certificate
authority to dole out TLS certificates.  This is achieved using the very handy
script EasyRSA, which streamlines the process of creating a Certificate Authority
and issuing keypairs into a handful of very short commands.
</p>


<figure>
<img src="../static/image/20200901_openvpn_diagram.png" alt="20200901_openvpn_diagram.png">

<figcaption><span class="figure-number">Figure 3: </span>OpenVPN topology.</figcaption>
</figure>

<p>
After setting up OpenVPN like I will outline below, one can simply run <code>ssh
10.100.0.10</code>, if the home server's VPN "virtual" IP is <code>10.100.0.0</code>.  Other
services hosted on the home server are also accessible by that IP.
</p>
</div>
</div>
</div>

<div id="outline-container-orgf61e06b" class="outline-2">
<h2 id="orgf61e06b">Steps to set up (based off my playbooks)</h2>
<div class="outline-text-2" id="text-orgf61e06b">
<p>
The following steps are based off of the <a href="https://openvpn.net/community-resources/how-to/">official OpenVPN
tutorial</a> for setting up multiple clients with their own
certificates.  This means a compromise of one client's
private key will not compromise the integrity of other
client private keys.
</p>
</div>

<div id="outline-container-orgabc7cda" class="outline-3">
<h3 id="orgabc7cda">Set up the certificate authority &amp; certificates</h3>
<div class="outline-text-3" id="text-orgabc7cda">
<div class="org-src-container">
<pre class="src src-sh"><span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">Download EasyRSA</span>
<span style="color: #ff69b4;">VERSION</span>=3.0.7
curl -O easy-rsa-${<span style="color: #ff69b4;">VERSION</span>}.tar.gz <span style="color: #61CE3C;">\</span>
    https://github.com/OpenVPN/easy-rsa/archive/v${<span style="color: #ff69b4;">VERSION</span>}.tar.gz
tar -xzvf easy-rsa-${<span style="color: #ff69b4;">VERSION</span>}.tar.gz
<span style="color: #4c83ff;">cd</span> easy-rsa-${<span style="color: #ff69b4;">VERSION</span>}/easyrsa3

<span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">Get script usage (it does not understand --help)</span>
./easyrsa help

<span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">One-time CA and DH params initialization</span>
./easyrsa init-pki
<span style="color: #4c83ff;">echo</span> <span style="color: #61CE3C;">'My Cool CA Name'</span> | ./easyrsa build-ca nopass
./easyrsa gen-dh

<span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">Do this for each OpenVPN Server.  Each server name</span>
<span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">(e.g. "my_server") must be unique.</span>
./easyrsa build-server-full my_server nopass

<span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">Do this for each OpenVPN Client.  Each client name</span>
<span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">(e.g. "my_client") must be unique.</span>
./easyrsa build-client-full my_client nopass
</pre>
</div>

<p>
The generated files used later in the install are:
</p>

<dl class="org-dl">
<dt><code>pki/ca.crt</code></dt><dd>The certificate authority public
certificate.  Install alongside any other
another <code>*.crt</code> file.  (Or maybe chain
them?)</dd>
<dt><code>pki/private/ca.key</code></dt><dd>The certificate authority private
certificate.</dd>
<dt><code>pki/dh.pem</code></dt><dd>Diffie Hellman parameters, TODO what is
this for?  Install on the server.</dd>
<dt><code>pki/issued/my_server.crt</code></dt><dd>The server public
certificate.  Install on the server.</dd>
<dt><code>pki/private/my_server.key</code></dt><dd>The server private
certificate.  Install on the server.</dd>
<dt><code>pki/issued/my_client.crt</code></dt><dd>The client public
certificate.  Install on the client.</dd>
<dt><code>pki/private/my_client.key</code></dt><dd>The client private
certificate.  Install on the client.</dd>
</dl>


<p>
I currently do not have the CA management scripted by Ansible.  I am a little
uncomfortable with the idea of Ansible entirely managing the CA creation
followed by certification creation.  More experience with Ansible should help
put my concerns at ease.  Chiefly, I don't want Ansible to write out
certificates from the "master CA tree".  Sometimes a little manual operation is
pgood.
</p>
</div>
</div>

<div id="outline-container-org2b654f1" class="outline-3">
<h3 id="org2b654f1">Set up the OpenVPN Server (Internet-side)</h3>
<div class="outline-text-3" id="text-org2b654f1">
<p>
<a href="https://gitlab.com/winny/personal-cloud/-/blob/master/roles/openvpn_server/tasks/main.yml">See the corresponding Ansible role's tasks.</a>
</p>

<p>
The server's <code>openvpn.conf</code> should look like this:
</p>

<pre class="example">
tls-server

port 12345

proto udp

dev tun0

ca /etc/openvpn/secrets/ca.crt
cert /etc/openvpn/secrets/{{inventory_hostname}}.crt
key /etc/openvpn/secrets/{{inventory_hostname}}.key
dh /etc/openvpn/secrets/dh.pem

server 10.100.0.0 255.255.255.0

persist-key
persist-tun

ifconfig-pool-persist ipp.txt
push "route 10.100.0.0 255.255.255.0"

keepalive 10 120
comp-lzo

user openvpn
group openvpn

status openvpn-status.log
log /var/log/openvpn/openvpn.log
verb 4
</pre>

<p>
This is probably the easiest part.
</p>

<ol class="org-ol">
<li>Install OpenVPN. <code>apk add openvpn</code></li>
<li>Install the CA keypair.<sup><a id="fnr.5" class="footref" href="#fn.5">5</a></sup></li>
<li>Install the VPN server's keypair.</li>
<li>Install the Diffie Hellman parameters file.</li>
<li>Install the server's openvpn.conf</li>
<li>Run the server <code>openvpn --config /etc/openvpn/openvpn.conf</code></li>
</ol>
</div>
</div>

<div id="outline-container-org72b01c1" class="outline-3">
<h3 id="org72b01c1">Set up the OpenVPN Client (Your Firewalled Host)</h3>
<div class="outline-text-3" id="text-org72b01c1">
<p>
<a href="https://gitlab.com/winny/personal-cloud/-/blob/master/roles/openvpn_client/tasks/main.yml">See the corresponding Ansible role's tasks.</a>
</p>

<p>
The client's <code>openvpn.conf</code> should look like this:
</p>

<pre class="example">
client

proto udp

dev tun0

remote public.example.com 12345

nobind
resolv-retry 30

script-security 2

ca /etc/openvpn/secrets/ca.crt
cert /etc/openvpn/secrets/{{inventory_hostname}}.crt
key /etc/openvpn/secrets/{{inventory_hostname}}.key

persist-key
persist-tun

keepalive 10 120
comp-lzo

log /var/log/openvpn/openvpn.log
verb 4
</pre>

<ol class="org-ol">
<li>Install OpenVPN. <code>apk add openvpn</code></li>
<li>Install the CA public key.</li>
<li>Install the VPN Client's keypair.</li>
<li>Install the client's openvpn.conf</li>
<li>Run the client using <code>openvpn --config /etc/openvpn/openvpn.conf</code></li>
</ol>
</div>
</div>

<div id="outline-container-org6358f82" class="outline-3">
<h3 id="org6358f82">Set up another OpenVPN client on your PC</h3>
<div class="outline-text-3" id="text-org6358f82">
<p>
Follow the same instructions as setting up your firewalled host, but be sure to
generate a unique SSL keypair to identify your PC.  If the OpenVPN server, the
firewalled host OpenVPN client, and your PC's OpenVPN client are all set up
correctly, you should be able to directly connect to any of the hosts
participating in the VPN via the VPN's private IPv4 network.
</p>
</div>
</div>
</div>

<div id="outline-container-orgb426dff" class="outline-2">
<h2 id="orgb426dff">Wishlist</h2>
<div class="outline-text-2" id="text-orgb426dff">
<p>
This setup works swimmingly, but there are a few nits in the amount of effort
involved in discovering hosts connected to the VPN.  I also realized instead of
only routing directly to other VPN clients, one could also join the various
LANs, so I gave that some thought as well.
</p>
</div>

<div id="outline-container-orgb3b4552" class="outline-3">
<h3 id="orgb3b4552">VPN Host Discovery</h3>
<div class="outline-text-3" id="text-orgb3b4552">
<p>
At present I scan for remote connected hosts via:
</p>

<pre class="example">
winston@snowcrash ~ $ sudo nmap -sP -PE 10.100.0.0/24
Password: 
Starting Nmap 7.80 ( https://nmap.org ) at 2020-08-15 01:31 CDT
Nmap scan report for 10.100.0.1
Host is up (0.026s latency).
Nmap scan report for 10.100.0.6
Host is up (0.053s latency).
Nmap scan report for 10.100.0.14
Host is up (0.064s latency).
Nmap scan report for 10.100.0.10
Host is up.
Nmap done: 256 IP addresses (4 hosts up) scanned in 2.61 seconds
</pre>

<p>
In the above output, <code>10.100.0.1</code> is the OpenVPN server
address, and according to <code>ip addr show dev tun0</code>, my
current OpenVPN client is <code>10.100.0.10</code>.
</p>

<p>
Pretty icky.  Alternatively, one can take a look at the server's <code>openvpn.log</code>:
</p>

<pre class="example">
Fri Aug 14 02:02:48 2020 us=357198 cyberdemon/127.0.0.1:42995 MULTI: primary virtual IP for cyberdemon/127.0.0.1:42995: 10.100.0.18
</pre>

<p>
In both cases it's a bit tedious to figure out which IP belongs to which host
participating on the VPN.
</p>

<p>
DNS-SD (via Avahi) might be suitable for this.  Instead of scanning for
available hosts, one can simply query for a DNS-SD (DNS Service Discovery)
type, quite possibly either <code>_http._tcp</code> or <code>_ssh._tcp</code>.  <a href="https://sosheskaz.github.io/tutorial/2016/09/26/Avahi-HTTP-Service.html">Here is one such
guide</a>.
</p>
</div>
</div>

<div id="outline-container-org63d31e1" class="outline-3">
<h3 id="org63d31e1">Domain Names for VPN Hosts</h3>
<div class="outline-text-3" id="text-org63d31e1">
<p>
An related wish (which overlaps in some ways) is to configure OpenVPN to
register VPN clients' information including their assigned IP address with a
DNS server such as dnsmasq or tinydns or even busybox's dns server.  I did some
skimming about this, and came up with the conclusion that it's possible, but is
not well understood or documented, so I decided to go with host discovery via
network scanning for the time being.
</p>
</div>
</div>

<div id="outline-container-org5f7d008" class="outline-3">
<h3 id="org5f7d008">Configure the VPN Clients' LAN segments be routable from other Clients</h3>
<div class="outline-text-3" id="text-org5f7d008">
<p>
This is a killer feature I have yet to figure out.  It appears possible, but
this requires a bit of further testing, and is relatively tricky to set up
correctly, since if a VPN Client ends up using the same IP network in two
different contexts, things will silently stop working without explanation,
because that's as intended, IP is funny like that.
</p>
</div>
</div>
</div>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" class="footnum" href="#fnr.1">1</a></sup> <div class="footpara"><p class="footpara">
<code>2001:db8:a:b::/64</code> is part of <code>2001:db8::/32</code> which is reserved for
documentation in <a href="https://tools.ietf.org/html/rfc3849">RFC 3849</a>.
</p></div></div>

<div class="footdef"><sup><a id="fn.2" class="footnum" href="#fnr.2">2</a></sup> <div class="footpara"><p class="footpara">
<code>203.0.113.1</code> is part of <code>203.0.113.0/24</code> (TEST-NET-3) which is reserved
for documentation in <a href="https://tools.ietf.org/html/rfc5737">RFC 5737</a>.
</p></div></div>

<div class="footdef"><sup><a id="fn.3" class="footnum" href="#fnr.3">3</a></sup> <div class="footpara"><p class="footpara">
Devices could be configured on the IPv4 LAN with so-called static IPv4
addresses, but usually you don't want this.  You can achieve the same by
assigning hosts the same IPv4 every time (which are identified the network
interface's MAC address or even the optional hostname field).
</p></div></div>

<div class="footdef"><sup><a id="fn.4" class="footnum" href="#fnr.4">4</a></sup> <div class="footpara"><p class="footpara">
In this example I use <code>192.168.1.0/24</code> which is reserved for private
network use in <a href="https://tools.ietf.org/html/rfc1918">RFC 1918</a>.
</p></div></div>

<div class="footdef"><sup><a id="fn.5" class="footnum" href="#fnr.5">5</a></sup> <div class="footpara"><p class="footpara">
The CA private key is likely not necessary and probably a serious smell,
if you know anything about this, please write me explaining this.
</p></div></div>


</div>
</div><div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-vpn.html">vpn</a> <a href="tag-networking.html">networking</a> <a href="tag-linux.html">linux</a> <a href="tag-devops.html">devops</a> </div><div id="archive">
<a href="archive.html">Other posts</a>
</div>
</div>
<div id="postamble" class="status">
<hr/>
<ul class="inline-list interpunct">
<li>Powered by <a href="https://github.com/bastibe/org-static-blog">org-static-blog</a></li>
<li>Like what I do? <a href="https://www.buymeacoffee.com/winny">Buy me a Coffee</a></li>
</ul>
<p>© Winston Weinert (winny) — <a href="https://creativecommons.org/licenses/by-sa/4.0/legalcode">CC-BY-SA-4.0</a></p>
</div>
</body>
</html>
